GNU bug report logs - #53520
[PATCH] tabulated-list gradually truncate image

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Thuna <thuna.cing@HIDDEN>; Keywords: patch; dated Tue, 25 Jan 2022 09:09:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 53520 <at> debbugs.gnu.org:


Received: (at 53520) by debbugs.gnu.org; 26 Jan 2022 13:12:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jan 26 08:12:05 2022
Received: from localhost ([127.0.0.1]:51187 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nCi5k-0000Fd-VS
	for submit <at> debbugs.gnu.org; Wed, 26 Jan 2022 08:12:05 -0500
Received: from quimby.gnus.org ([95.216.78.240]:47334)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nCi5i-0000F9-HG
 for 53520 <at> debbugs.gnu.org; Wed, 26 Jan 2022 08:12:03 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=4DOpQttkwLPvOrhYLX7T7r2PjGz3BamfE7tSmPmhj1k=; b=OJn3gE4JeYVM8qwHGUgKBibAWO
 LGCH8e/+4CvA6deRRv/c86sVwsIpbP54WLNalTF8pjnSVrJ9gvw7YihGQAQk4T8e28j4e/YjL3/eY
 b6YmLUI/N5wZ8J5kJmdqxGI6nVphRVAtnkXKXVNiBBT+Zs7B8FQaezG24uTiiawJSCRw=;
Received: from [84.212.220.105] (helo=giant)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nCi5a-00015u-6z; Wed, 26 Jan 2022 14:11:56 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Thuna <thuna.cing@HIDDEN>
Subject: Re: bug#53520: [PATCH] tabulated-list gradually truncate image
References: <87sftc2nel.fsf@HIDDEN> <87wniovswv.fsf@HIDDEN>
 <87fspb3ocy.fsf@HIDDEN> <87ilu7vq2x.fsf@HIDDEN>
 <87czkf3ips.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEVMQk6Zgm/07uPJ
 uqf///8KMbFVAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+YBGgw6MXNg61MAAAG2SURBVDjLdZQBsuQg
 CETxewGVC/zABRTuf7eF1mQyW7vWlJXxjdANZIioiEij0shUPotuUAPIN6giGjuR/AWGyEXEeTNi
 TeJGPzeYRI6QFo99HmCZghaABijrDcqVuURt9e5uCQpyl98A7vHs/gXqpKqpN4ECVIgKGxUyA6jf
 YL5A/KgzwIAophv0VvoBTmnjgNUatZGA/Rv0WADui9IGDEpI3jWmoh65y/oPqAlh46luVW8H4NCz
 lJcJsWbuG5hU0TV63GCL8NmDACY+RxuXpyqI2iDCrLJKVEUAZtoAUOmdx85Dbi/gqDCqHDfaNk7F
 sx/7E+XzfYbN0CI1HVch1xvUbIS5mP6oM0FUVWzquvo1rvR4wKbOkxejMgFSFCcg7dzMMaiXENT2
 nolycmAuhcEB1V8oiJ7tG+EEDmhMDLcm4O1kA1xj30tlpXOk5bkB7zrk5AAUKBiYzgfkUdH8OhBo
 9ReoLxCD3zFwUPtK3sLUHlEASHtumBwwAOwB/g1wHvp61zuUfwC3GN31gPXJgaH+B1jYjtzyBpBk
 BoMFzYohsehsvhuWICf6ANMT//yXPMD7C/wBIQFxXoGyh8kAAAAldEVYdGRhdGU6Y3JlYXRlADIw
 MjItMDEtMjZUMTI6NTg6NDkrMDA6MDD8giWrAAAAJXRFWHRkYXRlOm1vZGlmeQAyMDIyLTAxLTI2
 VDEyOjU4OjQ5KzAwOjAwjd+dFwAAAABJRU5ErkJggg==
X-Now-Playing: Dry Cleaning's _New Long Leg_: "John Wick"
Date: Wed, 26 Jan 2022 14:11:53 +0100
In-Reply-To: <87czkf3ips.fsf@HIDDEN> (Thuna's message of "Tue, 25 Jan 2022
 19:04:15 +0300")
Message-ID: <87h79qtzdy.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Thuna <thuna.cing@HIDDEN> writes: > PS: The actual point
 of the previous message, which went unanswered was: >> Considering the width
 of a column can be changed arbitrarily by the user >> is it not expected
 for tabulated-list to handl [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 53520
Cc: 53520 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Thuna <thuna.cing@HIDDEN> writes:

> PS: The actual point of the previous message, which went unanswered was:
>> Considering the width of a column can be changed arbitrarily by the user
>> is it not expected for tabulated-list to handle images in a way that
>> works for all widths?

I thought I answered that -- the package should advice the tabulated
list to do the thing it wants.

> PPS: I am thinking of carrying this conversation over to emacs-devel.
>      Are you okay with that?

Sure, go ahead.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#53520; Package emacs. Full text available.

Message received at 53520 <at> debbugs.gnu.org:


Received: (at 53520) by debbugs.gnu.org; 25 Jan 2022 16:04:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 25 11:04:25 2022
Received: from localhost ([127.0.0.1]:49797 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nCOIz-0008Fl-9d
	for submit <at> debbugs.gnu.org; Tue, 25 Jan 2022 11:04:25 -0500
Received: from mail-ed1-f46.google.com ([209.85.208.46]:34352)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thuna.cing@HIDDEN>) id 1nCOIx-0008FZ-Vp
 for 53520 <at> debbugs.gnu.org; Tue, 25 Jan 2022 11:04:24 -0500
Received: by mail-ed1-f46.google.com with SMTP id r10so33251041edt.1
 for <53520 <at> debbugs.gnu.org>; Tue, 25 Jan 2022 08:04:23 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version; bh=CnpjU1Rt2Mvv1SZJw/fUVT+uvbgXVMQUTktGOhDbbp8=;
 b=RqVfHMWrf8WCl6ZQPqQTKzMgs1DBCLlHkwq+/VZRf8oLQRpvSEUkhzwiUBs9UBPJR0
 3iGcEX++9wlty00fM8N4IpeGF87iEHy65Vqfn9gCIXSRRjjQ7/DMEojIFo7ZgKfH8xM8
 I5M3H9c9xpum21DuLJRjka3cvmoIYv8PLYy1jNxCGG1zpUUqh5o7ews6HI41Ek8IP7mU
 r43WWeTqSMotvURTNrG1CQeHG1ViDzj46B7q2Yn/Z6jeWABEnao12JnmQHs1jCMvTQBg
 57jZuEnPU/ZMA3jhtSlKakeF6QiMtcW4QeaeJoFgZQGL5JaL4QoZedKhCQlUL2ZnxfEw
 BQ9Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version;
 bh=CnpjU1Rt2Mvv1SZJw/fUVT+uvbgXVMQUTktGOhDbbp8=;
 b=BdxRq9j9fu0JsvWUUDFSo1uzGO1pKsyXeKembUJbRMm/6nidMerTwAHMLY/DFpSriu
 E3VvJVxBhNoq6YwYbR1EaEMirptkaWQ5qHw5kHY1nyGcotbVcefokJdZhcggBtIfRYs2
 s+01elJ4Z4DFvo9fxCYOtwRKzwm9LCooaQvwmq5KIC2WNJrGeMXxJZ93t/WT/8XpSF82
 v6DDdBBVdKlnchfne8KnAYPQV8/fqL6CSHLkqn7pXUPYEKKgPc+sCqHgxbG2l7LfSkK+
 AzeqSod8eMFaxHJDfxvgax8p+FQ5GWISoxbVB/YcPKby/zGbEuzs+36Yxxo9ZHwFngGK
 rKIA==
X-Gm-Message-State: AOAM531NLnxPDAd1p391/Ut6kzlCIdbSvsOBISXvkgnGfHO/w7ArrtyE
 2YdENggu0SzkJWzZNpkRkVPWlVFcA4c=
X-Google-Smtp-Source: ABdhPJzSrz+EoZuVodT+IcxMjeHoYP1pSdnFvVLy309ewG9uJHu/6LMUUE1HWwb69Y6xg1yqQDm66w==
X-Received: by 2002:a05:6402:4487:: with SMTP id
 er7mr20826673edb.63.1643126657803; 
 Tue, 25 Jan 2022 08:04:17 -0800 (PST)
Received: from Thuna ([78.161.73.233])
 by smtp.gmail.com with ESMTPSA id g9sm6265855ejf.33.2022.01.25.08.04.16
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 25 Jan 2022 08:04:17 -0800 (PST)
From: Thuna <thuna.cing@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#53520: [PATCH] tabulated-list gradually truncate image
In-Reply-To: <87ilu7vq2x.fsf@HIDDEN>
References: <87sftc2nel.fsf@HIDDEN> <87wniovswv.fsf@HIDDEN>
 <87fspb3ocy.fsf@HIDDEN> <87ilu7vq2x.fsf@HIDDEN>
Date: Tue, 25 Jan 2022 19:04:15 +0300
Message-ID: <87czkf3ips.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 53520
Cc: 53520 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


> I think you're trying to use the mode for things it's not really
> suited for, and adding things like this will only be half measures.

A clarification on what exactly is expected of tabulated-list-mode with
regards to the current issue and how it fails to (in an unamendable way)
fulfill those expectations would be appreciated.

---

> There's a lot of things the package using the mode could want to have
> done with the contents of the table,

Image resizing can be handled the same way `tabulated-list-printer' is
currently handled; as a variable that points to a function, whose
built-in value supports most common needs.  That would solve the issue
of packages being incapable of controlling the process.

> and modes can advise tabulated-list-print to do these transforms if
> they want to.

As it stands, the variable `tabulated-list-printer' is used to control
the way printing is done and any package that wants to print differently
should be setting that variable to their own printing function.
Packages should not be exposed to the printing process unless they are
offering functionality that /cannot/ be handled by tabulated-list.

---

PS: The actual point of the previous message, which went unanswered was:
> Considering the width of a column can be changed arbitrarily by the user
> is it not expected for tabulated-list to handle images in a way that
> works for all widths?

---

PPS: I am thinking of carrying this conversation over to emacs-devel.
     Are you okay with that?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#53520; Package emacs. Full text available.

Message received at 53520 <at> debbugs.gnu.org:


Received: (at 53520) by debbugs.gnu.org; 25 Jan 2022 14:37:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 25 09:37:56 2022
Received: from localhost ([127.0.0.1]:47642 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nCMxI-0003BH-Bm
	for submit <at> debbugs.gnu.org; Tue, 25 Jan 2022 09:37:56 -0500
Received: from quimby.gnus.org ([95.216.78.240]:35904)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nCMxE-0003B1-69
 for 53520 <at> debbugs.gnu.org; Tue, 25 Jan 2022 09:37:55 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=KnxcMGEAbDL7wFl4KO5ATM52bgPJGnGmxb1WKVXok40=; b=XT1hGQnHGWCzLuXStn7WcP+/xB
 3T9j2bbTb3RgcQASglbb+KvGWefQrDP9thYqQJlh1o/KkVyVPKMfvcLgxZc4EcQdYlQ4KQxm8p38b
 cMo+7LAvWn7ajArLf4sS3F9o0puodn/B+kKUI5V6QqB0olQHXaPEM1R/vXbtSYxDh4e8=;
Received: from [84.212.220.105] (helo=giant)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nCMx4-0004w6-Vq; Tue, 25 Jan 2022 15:37:45 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Thuna <thuna.cing@HIDDEN>
Subject: Re: bug#53520: [PATCH] tabulated-list gradually truncate image
References: <87sftc2nel.fsf@HIDDEN> <87wniovswv.fsf@HIDDEN>
 <87fspb3ocy.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAIVBMVEX9/f3m3dPBsahu
 b4tJNk8VESDXqpjLkGuzX1OcGB3///9W6Q8RAAAAAWJLR0QKaND0VgAAAAd0SU1FB+YBGQ4WL6Fv
 xh4AAAGvSURBVDjLzZLNT8IwGMZbD6i3ddOBNwbG6E3sEvUm0CZyVNfEo/gB7AZoZNwgfG03MWb2
 /W/t/MBt6FmfbEnz/PL0fd+2CP2xdINVCz8Bgwoh8su+2axyzpYBbo1p3utqy6Ch023ooHrKbxCE
 iV0bZiCV6TV0a1ey9laI0sA8DUASd5ACnte5Zb1aH+QsWUV6sxvoiENQSlTxx6c+zPmOr0BiN0y2
 AULbfD4CkIkIvg4gpKujvIpcxX2zewyvuntvzVQyFsEd88CTpF/MjmqKxCKH2ZtjqPt07eE8AGh/
 J/jMBqi/VnI2mdRi9Ve4U3Gh/lKSlgsC4GmRsKtWDqZObpgDEA4s7sWgFGVBWs2WapeLy+++jBIy
 AUjkD7kQzoJg9en6o/Knhrp7sZ88ZNVpqEe+cPIpILViQRZZmuzBFdEyISJ38TJK6/OsHwQXWMM8
 +cYy08D3J5GlJm4QoqHPGO4WKOXiLDqLigIIkQ+CRzxqqfw1gRL5WD8zxpJlP4ncVKCcHO6dBLrD
 nNTTwtEG/YHNT1CaqN8NNy7QkjSEXbjdRz8JEw39S+FfCYmt3wBg+4M+5wst3QAAACV0RVh0ZGF0
 ZTpjcmVhdGUAMjAyMi0wMS0yNVQxNDoyMjo0NyswMDowMBuJsJMAAAAldEVYdGRhdGU6bW9kaWZ5
 ADIwMjItMDEtMjVUMTQ6MjI6NDcrMDA6MDBq1AgvAAAAAElFTkSuQmCC
X-Now-Playing: David Bowie's _Brilliant Adventure (11): Re:Call 5_: "Survive
 (Marius de Vries mix)"
Date: Tue, 25 Jan 2022 15:37:42 +0100
In-Reply-To: <87fspb3ocy.fsf@HIDDEN> (Thuna's message of "Tue, 25 Jan 2022
 17:02:21 +0300")
Message-ID: <87ilu7vq2x.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Thuna <thuna.cing@HIDDEN> writes: > I do not wholly
 disagree
 that the current strategy of slicing the image > may not be the ideal solution
 for all situations, however is it not > better to handle images even if done
 poorly (which I w [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 53520
Cc: 53520 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Thuna <thuna.cing@HIDDEN> writes:

> I do not wholly disagree that the current strategy of slicing the image
> may not be the ideal solution for all situations, however is it not
> better to handle images even if done poorly (which I would argue is not
> the case) than it is to not handle them altogether?
>
> Other methods of (yet unimplemented) resizing an image include scaling
> it down and hiding it when it doesn't fit.  All of these methods have
> their use cases and it should be relatively simple to introduce a
> variable that controls which one is used.

I think you're trying to use the mode for things it's not really suited
for, and adding things like this will only be half measures.  There's a
lot of things the package using the mode could want to have done with
the contents of the table, and modes can advise tabulated-list-print to
do these transforms if they want to.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#53520; Package emacs. Full text available.

Message received at 53520 <at> debbugs.gnu.org:


Received: (at 53520) by debbugs.gnu.org; 25 Jan 2022 14:02:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 25 09:02:34 2022
Received: from localhost ([127.0.0.1]:47495 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nCMP4-0008Pn-M7
	for submit <at> debbugs.gnu.org; Tue, 25 Jan 2022 09:02:34 -0500
Received: from mail-ed1-f48.google.com ([209.85.208.48]:43820)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thuna.cing@HIDDEN>) id 1nCMP0-0008Ib-7g
 for 53520 <at> debbugs.gnu.org; Tue, 25 Jan 2022 09:02:32 -0500
Received: by mail-ed1-f48.google.com with SMTP id w14so10035768edd.10
 for <53520 <at> debbugs.gnu.org>; Tue, 25 Jan 2022 06:02:30 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version; bh=CY15TWF8MNExWIqZrs3A6mOa7SIhXXPRy3wVJY6Jn9o=;
 b=mjmNxoeTFlYlwgXRYgfcSMuDdVCMebf4KDwI8e1/bohlhHm8vb5j6IzLBTQb9lqsDP
 8copw3Kdh9dvNmAYy/UP88Bri8CJXA2llT8//hzkg6JFI4sm6I54raM/xmq7QoIVjlFO
 Rj9f9k18iA7gg1VX+F4P0+gxcx4v508MjaRxAWT2Q8PQ2GNulI9MYbQiAN6aK8r98W8h
 xruUnjfYyKuUSU5qt0lvSdAat9h8psd5ZiLInuQhrO0FgOnwm5K9bN3I5d0vx3KyN0OU
 UsxQqHnzQS3DyY2hnk3dnLycUdKyZq6dtDRgJboRF72U/W4BeDvKT3Vifef8MYf/LOfk
 m1WA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:from:to:cc:subject:in-reply-to:references:date
 :message-id:mime-version;
 bh=CY15TWF8MNExWIqZrs3A6mOa7SIhXXPRy3wVJY6Jn9o=;
 b=O3Z5bTxMsk0oRZJawv3PltVE+IMMTTibwU04ljDZW0lntsEfsm4/X0sZ16CGb3YWFJ
 CM2OY80VdLdAUdQKlqqxwLMJvKVrghFWpJL/Ii7UmmC7VyUwkEaJloSp7yreb3YBfroE
 hthrzlLZf61XEaNTJZ6Qie7oaR53jHEm4Ov0ctslgTLaCAsLKrT8vZrZoETK6wlXgCKt
 HOjhSr/H3ybtz5BaHKq1mrKc5U60ge2YlxfPE/dKr2bQxWTgr/FNvZ2adCmhaOlkSDgC
 UFmGieBFpeY8lhYHIUHXCoWV1wbaERUAFC54DChHOAEl6NvFUa5BdO86BaF2crK+3Bpw
 LI+w==
X-Gm-Message-State: AOAM532lFVREJFOBXfY81OxqA2jTP2g7N+d4r0yq9+j4BKAx0J5ocuo4
 9RXVN79pEWaTr1jZ9UCsFfOLTPKH+d0=
X-Google-Smtp-Source: ABdhPJw3ND7OEohqGRj2r0r6KIMTraqvw9cwUf77EWYkfGKbV7GlPSDgBxY9tI5RmkMRMr6XgDjJzg==
X-Received: by 2002:a17:907:90d5:: with SMTP id
 gk21mr3385055ejb.297.1643119343833; 
 Tue, 25 Jan 2022 06:02:23 -0800 (PST)
Received: from Thuna ([78.161.73.233])
 by smtp.gmail.com with ESMTPSA id gg14sm6231256ejb.159.2022.01.25.06.02.22
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 25 Jan 2022 06:02:22 -0800 (PST)
From: Thuna <thuna.cing@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#53520: [PATCH] tabulated-list gradually truncate image
In-Reply-To: <87wniovswv.fsf@HIDDEN>
References: <87sftc2nel.fsf@HIDDEN> <87wniovswv.fsf@HIDDEN>
Date: Tue, 25 Jan 2022 17:02:21 +0300
Message-ID: <87fspb3ocy.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 53520
Cc: 53520 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


> I think it a tabulated-list caller wants to insert images into the
> table, they should ensure that the width of the image is appropriate for
> the column.

Considering the width of a column can be changed arbitrarily by the user
is it not expected for tabulated-list to handle images in a way that
works for all widths?

> And as you say, this only chops off the parts of the image -- I think
> it's more likely that a caller would want to set the width with
> :max-width or the like.

I do not wholly disagree that the current strategy of slicing the image
may not be the ideal solution for all situations, however is it not
better to handle images even if done poorly (which I would argue is not
the case) than it is to not handle them altogether?

Other methods of (yet unimplemented) resizing an image include scaling
it down and hiding it when it doesn't fit.  All of these methods have
their use cases and it should be relatively simple to introduce a
variable that controls which one is used.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#53520; Package emacs. Full text available.

Message received at 53520 <at> debbugs.gnu.org:


Received: (at 53520) by debbugs.gnu.org; 25 Jan 2022 13:36:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 25 08:36:46 2022
Received: from localhost ([127.0.0.1]:47433 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nCM05-0003D3-QR
	for submit <at> debbugs.gnu.org; Tue, 25 Jan 2022 08:36:45 -0500
Received: from quimby.gnus.org ([95.216.78.240]:35192)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1nCM03-0003Cn-To
 for 53520 <at> debbugs.gnu.org; Tue, 25 Jan 2022 08:36:44 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=mtb8RY8+susoWRbjUYVVi6RIMhREesB/GWVfTjeQCE8=; b=FeeIBqpNP0pXJwrocl1zTaCJKI
 OMqtrkbwFq3N3ug6pa0XPOhdpmApAcN4LsZUoVUGQDaFyV4SwUA4Gm8y6yvWd7ITjRHmGV+WDs+PK
 WG1OYG3MOAU1IIxVz3d9daFXsVvhIDWA/PZhAkDcBvXxr7cuA06RKBtEgWzW5VQR6epw=;
Received: from [84.212.220.105] (helo=giant)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1nCLzv-0004HH-1u; Tue, 25 Jan 2022 14:36:37 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Thuna <thuna.cing@HIDDEN>
Subject: Re: bug#53520: [PATCH] tabulated-list gradually truncate image
References: <87sftc2nel.fsf@HIDDEN>
X-Now-Playing: A Foggy Day In London Town's _Brilliant Adventure (10):
 Re:Call 5_: "David Bowie and Angelo Badalamenti"
Date: Tue, 25 Jan 2022 14:36:32 +0100
In-Reply-To: <87sftc2nel.fsf@HIDDEN> (Thuna's message of "Tue, 25 Jan 2022
 12:08:18 +0300")
Message-ID: <87wniovswv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Thuna <thuna.cing@HIDDEN> writes: > Previously images were
 displayed as is which would potentially cause > misalignment if the column
 width were less than the image width. Image > is now cropped width-wise to
 fit the column width. Thi [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 53520
Cc: 53520 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Thuna <thuna.cing@HIDDEN> writes:

> Previously images were displayed as is which would potentially cause
> misalignment if the column width were less than the image width.  Image
> is now cropped width-wise to fit the column width.  This patch, however,
> does not affect the height of the image.

[...]

> +                                          (slice 0.0 0.0
> +                                                 ,(* (frame-char-width)
> +                                                     available-space)

I think it a tabulated-list caller wants to insert images into the
table, they should ensure that the width of the image is appropriate for
the column.  And as you say, this only chops off the parts of the
image -- I think it's more likely that a caller would want to set the
width with :max-width or the like.

So I don't think this makes all that much sense as a feature.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#53520; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Jan 2022 09:08:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 25 04:08:32 2022
Received: from localhost ([127.0.0.1]:46847 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1nCHoV-0007bo-QO
	for submit <at> debbugs.gnu.org; Tue, 25 Jan 2022 04:08:32 -0500
Received: from lists.gnu.org ([209.51.188.17]:50410)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <thuna.cing@HIDDEN>) id 1nCHoR-0007be-DC
 for submit <at> debbugs.gnu.org; Tue, 25 Jan 2022 04:08:30 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54956)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <thuna.cing@HIDDEN>)
 id 1nCHoQ-0003ZK-DQ
 for bug-gnu-emacs@HIDDEN; Tue, 25 Jan 2022 04:08:27 -0500
Received: from [2a00:1450:4864:20::52c] (port=37486
 helo=mail-ed1-x52c.google.com)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <thuna.cing@HIDDEN>)
 id 1nCHoO-0001P2-4a
 for bug-gnu-emacs@HIDDEN; Tue, 25 Jan 2022 04:08:25 -0500
Received: by mail-ed1-x52c.google.com with SMTP id c24so59243854edy.4
 for <bug-gnu-emacs@HIDDEN>; Tue, 25 Jan 2022 01:08:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20210112;
 h=from:to:subject:date:message-id:mime-version;
 bh=dRjjTPWJmbdb1Ny1ctMS+EgWp+MuXaAaXXo+1dS6/Nk=;
 b=VTteu8ZPoBBGYm7owC0i1LaVLYiebD7PRMgRJ+Uh1ZzX3eCiD1P004ywGuCLYKgrW1
 FvaLApucQzlL/NF3PInou5M6zKMBgNpyaoH+uEXRH5P6gsGbmdkGqAyKmZY/oxHL/B1w
 bDcxZOdtKL1e+D8IUp/5OaDOAhrefb0ucuB5yVxPuxE0B70Nl1pJzBvH+IbO2VTkZlHZ
 PE5Ljtqbi6T4Q7G7JM+/7P3W5oitOWqYO8euRkK7oM4c2IERkot+/S9ISjktQQ8ZhwUZ
 38LKHfot3aV2hrxzQHYNyCMqOLUjc5ON3JothzqcLoFWYlG3DWdw71VK/LZnGRIa4zvc
 7oag==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20210112;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=dRjjTPWJmbdb1Ny1ctMS+EgWp+MuXaAaXXo+1dS6/Nk=;
 b=e4/v/QQL3ZdJX7q3rB6qUwKlPvd3U05+BIIVHRVzkGeXLm540FjF2Uxxs4OX6+CjO8
 Hb2ADWg/qlaIoLkQX+4hMP9eQzvHt/fW5U6ln6V8nsd1Zvao6UpEQ182IjSdq0nJXM+z
 1i0fZ0jUAxWC8J8i/QpcMSrnBB6Gy5gPZ0b8kpYMJn5SIlrzxKXn4zI4hERhK6etPNEl
 21qUWt7UriYlRw1Yo2+5ezqgsYtAXyDeKL+ZMpkZQ2DFDsk4/ktXzZEHrbN5QQ65VMiq
 WyKdQm2aWH2gkyM0gCuq5l+Ct1cuDnsr2BTDvcVtPU1M73Idc+lcWL1o/Uh2PFp52qLl
 whIQ==
X-Gm-Message-State: AOAM533j9ptJ8hNYSuDweKJrhdwI+vR+0e3m+/Hcscnl1it6j4cRfuX1
 RHjm7qyaMwea0GHAsn8y0D9ZP3SORaw=
X-Google-Smtp-Source: ABdhPJzJLgIZQV0N3OXhItn68S5jOSEFb8B/WI7CjsB3+KyVhDq4ZDci5Gw5AvY/NyfSHyJPO4ccZw==
X-Received: by 2002:a05:6402:4383:: with SMTP id
 o3mr7161991edc.353.1643101700801; 
 Tue, 25 Jan 2022 01:08:20 -0800 (PST)
Received: from Thuna ([78.161.73.233])
 by smtp.gmail.com with ESMTPSA id lv15sm5862628ejb.51.2022.01.25.01.08.19
 for <bug-gnu-emacs@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 25 Jan 2022 01:08:19 -0800 (PST)
From: Thuna <thuna.cing@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: [PATCH] tabulated-list gradually truncate image
Date: Tue, 25 Jan 2022 12:08:18 +0300
Message-ID: <87sftc2nel.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Host-Lookup-Failed: Reverse DNS lookup failed for 2a00:1450:4864:20::52c
 (failed)
Received-SPF: pass client-ip=2a00:1450:4864:20::52c;
 envelope-from=thuna.cing@HIDDEN; helo=mail-ed1-x52c.google.com
X-Spam_score_int: -12
X-Spam_score: -1.3
X-Spam_bar: -
X-Spam_report: (-1.3 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 PDS_HP_HELO_NORDNS=0.001, RCVD_IN_DNSWL_NONE=-0.0001, RDNS_NONE=0.793,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 1.4 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: Previously images were displayed as is which would
 potentially
 cause misalignment if the column width were less than the image width. Image
 is now cropped width-wise to fit the column width. This patc [...] 
 Content analysis details:   (1.4 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (thuna.cing[at]gmail.com)
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [209.51.188.17 listed in wl.mailspike.net]
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
 medium trust [209.51.188.17 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
 1.3 SPOOFED_FREEMAIL       No description available.
 1.5 SPOOF_GMAIL_MID        From Gmail but it doesn't seem to be...
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

--=-=-=
Content-Type: text/plain


Previously images were displayed as is which would potentially cause
misalignment if the column width were less than the image width.  Image
is now cropped width-wise to fit the column width.  This patch, however,
does not affect the height of the image.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-tabulated-list-gradually-collapse-images.patch

diff --git a/lisp/emacs-lisp/tabulated-list.el b/lisp/emacs-lisp/tabulated-list.el
index 2ace7ebb35..b964dd56e9 100644
--- a/lisp/emacs-lisp/tabulated-list.el
+++ b/lisp/emacs-lisp/tabulated-list.el
@@ -577,7 +577,11 @@ tabulated-list-print-col
                      (propertize label 'help-echo help-echo))))
           ((eq (car col-desc) 'image)
            (insert (propertize " "
-                               'display col-desc
+                               'display `(,col-desc
+                                          (slice 0.0 0.0
+                                                 ,(* (frame-char-width)
+                                                     available-space)
+                                                 1.0))
                                'help-echo help-echo)))
           ((apply 'insert-text-button label (cdr col-desc))))
     (let ((next-x (+ x pad-right width)))

--=-=-=--




Acknowledgement sent to Thuna <thuna.cing@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#53520; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 26 Jan 2022 13:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.